/* 08 / 24 / 2007 */
/* IP Reporter */
/* Author: DarkRanger<darkranger.no-ip.org> */
/* Codename: DR-P-7 */
/* License: GNU Lesser General Public License */

/////////////////////////////////////////////////////////////////////////////////////

/*Included/Required header files.*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <net/if.h>

#include <time.h>
#include <sys/utsname.h>

#define VERSION "1.0"
#define BUILD "20070824"

/////////////////////////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
 int Line = 0 , Send_Mail = 0 ;
 char Scanner[255] = "", Device[255] = "", Mail_Address[255] = "", 
 Previous_IP[255] = "", Current_IP[255] = "", Command[255] = "" ;
 
 int inet_sock;
 struct ifreq ifr;
 struct sockaddr_in *device_data; 

 struct utsname hostname ;

 time_t timep ;

 FILE *SETUP, *IP_SAVE, *MAIL_TEXT ;

/////////////////////////////////////////////////////////////////////////////////////

 //printf("IP Reporter v%s build %s is running now.\n", VERSION, BUILD) ;

 SETUP = fopen("/etc/ip-reporter/ip-reporter.conf","r");
 if ( SETUP != NULL )
   {
     while ( Line < 4 )
       {
        fscanf(SETUP, "%s", Scanner);
        if ( Line == 1 )
           {
            strcpy(Device, Scanner);
           } 
        if ( Line == 3 )
           {
            strcpy(Mail_Address, Scanner);
            break ;
           } 
        Line ++ ;
       }
    fclose(SETUP);    
   }
 else
   {
     SETUP = fopen("/etc/ip-reporter/ip-reporter.conf","w");
     if ( SETUP != NULL )
       {
         fprintf(SETUP,"[device]\n");
         fprintf(SETUP,"ppp0\n");    
         fprintf(SETUP,"[mail]\n");   
         fprintf(SETUP,"root@localhost\n");  
         fclose(SETUP); 
       } 
     strcpy(Device,"ppp0");
     strcpy(Mail_Address,"root@localhost");      
   }
   
 //printf("PPPoE Device = %s\n", Device);
 //printf("E-Mail = %s\n", Mail_Address);

/////////////////////////////////////////////////////////////////////////////////////

 IP_SAVE = fopen ( "/var/lib/ip-reporter/ip.save", "r" ) ;

 if ( IP_SAVE != NULL )
   {
     fscanf(IP_SAVE, "%s", Previous_IP);
     fclose(IP_SAVE);
   }
 else
   {
     strcpy(Previous_IP,"null");
   }
 //printf("Previous IP = %s\n", Previous_IP);

/////////////////////////////////////////////////////////////////////////////////////

 inet_sock = socket(AF_INET, SOCK_DGRAM, 0);
 strcpy(ifr.ifr_name, Device);

 if (ioctl(inet_sock, SIOCGIFADDR, &ifr) < 0)
   {
     perror("ioctl");
   }
 else
  {
    device_data=(struct sockaddr_in*)&(ifr.ifr_addr); 
    sprintf(Current_IP, "%s",inet_ntoa(device_data->sin_addr));
    //printf("Current IP = %s\n", Current_IP); 
    if ( strcmp ( Current_IP, Previous_IP ) != 0 )
      {
        IP_SAVE = fopen ( "/var/lib/ip-reporter/ip.save", "w" ) ;
        if ( IP_SAVE != NULL )
          {
            fprintf(IP_SAVE,"%s", Current_IP);
            fclose(IP_SAVE);
            Send_Mail = 1 ;
          }
      }
      
  }

/////////////////////////////////////////////////////////////////////////////////////
 
 if ( Send_Mail == 1 )
  {
    MAIL_TEXT = fopen("/var/lib/ip-reporter/mail.txt", "w");
    if ( MAIL_TEXT != NULL )
      {
        fprintf(MAIL_TEXT, "This a mail from IP Reporter v%s build %s.\n", VERSION, BUILD);

        fprintf(MAIL_TEXT, "Current IP is %s\n", Current_IP);
        fprintf(MAIL_TEXT, "Previous IP is %s\n", Previous_IP);

        uname(&hostname); 
        //printf("Server is %s\n", hostname.nodename) ;
        fprintf(MAIL_TEXT, "Server is %s\n", hostname.nodename);
        //printf("OS is %s\n", hostname.sysname) ; 
        fprintf(MAIL_TEXT, "OS is %s\n", hostname.sysname);
        //printf("Kernel is %s\n", hostname.release) ;
        fprintf(MAIL_TEXT, "Kernel is %s\n", hostname.release);
    
        time(&timep) ;
        //printf("Report at %s\n", asctime(localtime(&timep))) ;
        fprintf(MAIL_TEXT, "Report at %s\n", asctime(localtime(&timep))) ;
        fclose(MAIL_TEXT);
    
        sprintf(Command, "mail -s \"Mail form IP Reporter\" %s < /var/lib/ip-reporter/mail.txt", Mail_Address);
        //printf("%s\n",Command);
        system(Command);
      }
  }

 return 0 ;
}
